Shader "Unlit/YVRHandDepthOnlyBuildinRP"
{
    Properties
    {
        
    }
    SubShader
    {
        Tags { "RenderType"="Opaque" "IgnoreProjector"="True"}
        LOD 300

        Pass
        {
            ZWrite On
            ColorMask 0
            Cull Off

            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            // make fog work
            #pragma multi_compile_fog

            #include "UnityCG.cginc"

            struct appdata 
            {
                float4 vertex : POSITION;
            };

            struct v2f
            {
                float4 vertex : SV_POSITION;
                float depth : DEPTH;
            };

            v2f vert (appdata v)
            {
                v2f o;
                o.vertex = UnityObjectToClipPos(v.vertex);
                o.depth = ComputeGrabScreenPos(o.vertex).z;
                return o;
            }

            fixed4 frag (v2f i) : SV_Target
            {
                UNITY_OUTPUT_DEPTH(i.depth);
            }
            ENDCG
        }
    }
}
